using System;
using System.Data;
using System.Runtime.InteropServices;

namespace ADSLibrary
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class ADSmartIO
	{
		public enum PortName
		{
			A = 0,
			B = 1,
			C = 2,
			D = 3
		}

		#region SMARTIO.DLL Function Imports
		//---------- SMARTIO DEFINITIONS ----------

		[DllImport("smartio.dll", EntryPoint="SIOFirmwareVersion" )]
		private static extern uint SIOFirmwareVersionS();

		[DllImport("smartio.dll", EntryPoint="SIOReadDeviceVersion" )]
		private static extern uint SIOReadDeviceVersionS();

		[DllImport("smartio.dll", EntryPoint="SIOReadDevicePartType" )]
		private static extern uint SIOReadDevicePartTypeS();

		[DllImport("smartio.dll", EntryPoint="SIOReadKeypad" )]
		private static extern byte SIOReadKeypadS();

		[DllImport("smartio.dll", EntryPoint="SIOSetKeyPadSize" )]
		private static extern bool SIOSetKeyPadSizeS(byte cols, byte rows);

		[DllImport("smartio.dll", EntryPoint="SIOSetSpeaker" )]
		private static extern bool SIOSetSpeakerS(byte duration, byte tone);

		[DllImport("smartio.dll", EntryPoint="SIOAnalogConversion" )]
		private static extern uint SIOAnalogConversionS(byte channel);

		[DllImport("smartio.dll", EntryPoint="SIOReadVoltage" )]
		private static extern uint SIOReadVoltageS();

		[DllImport("smartio.dll", EntryPoint="SIOReadTemperature" )]
		private static extern uint SIOReadTemperatureS();

		[DllImport("smartio.dll", EntryPoint="SIOSelectOption" )]
		private static extern void SIOSelectOptionS(byte option);

		[DllImport("smartio.dll", EntryPoint="SIOBackLightPwm" )]
		private static extern void SIOBackLightPwmS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOBackLightVEEPwm" )]
		private static extern void SIOBackLightVEEPwmS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOBackLightON" )]
		private static extern void SIOBackLightONS();

		[DllImport("smartio.dll", EntryPoint="SIOBackLightOFF" )]
		private static extern void SIOBackLightOFFS();

		[DllImport("smartio.dll", EntryPoint="SIOWritePortA" )]
		private static extern void SIOWritePortAS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOWritePortB" )]
		private static extern void SIOWritePortBS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOWritePortC" )]
		private static extern void SIOWritePortCS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOWritePortD" )]
		private static extern void SIOWritePortDS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOReadPortA" )]
		private static extern uint SIOReadPortAS();

		[DllImport("smartio.dll", EntryPoint="SIOReadPortB" )]
		private static extern uint SIOReadPortBS();

		[DllImport("smartio.dll", EntryPoint="SIOReadPortC" )]
		private static extern uint SIOReadPortCS();

		[DllImport("smartio.dll", EntryPoint="SIOReadPortD" )]
		private static extern uint SIOReadPortDS();

		[DllImport("smartio.dll", EntryPoint="SIOInitDDRA" )]
		private static extern void SIOInitDDRAS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOInitDDRB" )]
		private static extern void SIOInitDDRBS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOInitDDRC" )]
		private static extern void SIOInitDDRCS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOInitDDRD" )]
		private static extern void SIOInitDDRDS(byte val);

		[DllImport("smartio.dll", EntryPoint="SIOSetSSPTimeout" )]
		private static extern bool SIOSetSSPTimeoutS(ulong timeout);

		#endregion

		#region KEYBDDR.DLL Function Imports
		//---------- KEYBDDR DEFINITIONS ----------
		
		[DllImport("keybddr.dll", EntryPoint="SIOFirmwareVersion" )]
		private static extern uint SIOFirmwareVersionK();

		[DllImport("keybddr.dll", EntryPoint="SIOReadDeviceVersion" )]
		private static extern uint SIOReadDeviceVersionK();

		[DllImport("keybddr.dll", EntryPoint="SIOReadDevicePartType" )]
		private static extern uint SIOReadDevicePartTypeK();

		[DllImport("keybddr.dll", EntryPoint="SIOReadKeypad" )]
		private static extern byte SIOReadKeypadK();

		[DllImport("keybddr.dll", EntryPoint="SIOSetKeyPadSize" )]
		private static extern bool SIOSetKeyPadSizeK(byte cols, byte rows);

		[DllImport("keybddr.dll", EntryPoint="SIOSetSpeaker" )]
		private static extern bool SIOSetSpeakerK(byte duration, byte tone);

		[DllImport("keybddr.dll", EntryPoint="SIOAnalogConversion" )]
		private static extern uint SIOAnalogConversionK(byte channel);

		[DllImport("keybddr.dll", EntryPoint="SIOReadVoltage" )]
		private static extern uint SIOReadVoltageK();

		[DllImport("keybddr.dll", EntryPoint="SIOReadTemperature" )]
		private static extern uint SIOReadTemperatureK();

		[DllImport("keybddr.dll", EntryPoint="SIOSelectOption" )]
		private static extern void SIOSelectOptionK(byte option);

		[DllImport("keybddr.dll", EntryPoint="SIOBackLightPwm" )]
		private static extern void SIOBackLightPwmK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOBackLightVEEPwm" )]
		private static extern void SIOBackLightVEEPwmK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOBackLightON" )]
		private static extern void SIOBackLightONK();

		[DllImport("keybddr.dll", EntryPoint="SIOBackLightOFF" )]
		private static extern void SIOBackLightOFFK();

		[DllImport("keybddr.dll", EntryPoint="SIOWritePortA" )]
		private static extern void SIOWritePortAK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOWritePortB" )]
		private static extern void SIOWritePortBK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOWritePortC" )]
		private static extern void SIOWritePortCK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOWritePortD" )]
		private static extern void SIOWritePortDK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOReadPortA" )]
		private static extern uint SIOReadPortAK();

		[DllImport("keybddr.dll", EntryPoint="SIOReadPortB" )]
		private static extern uint SIOReadPortBK();

		[DllImport("keybddr.dll", EntryPoint="SIOReadPortC" )]
		private static extern uint SIOReadPortCK();

		[DllImport("keybddr.dll", EntryPoint="SIOReadPortD" )]
		private static extern uint SIOReadPortDK();

		[DllImport("keybddr.dll", EntryPoint="SIOInitDDRA" )]
		private static extern void SIOInitDDRAK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOInitDDRB" )]
		private static extern void SIOInitDDRBK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOInitDDRC" )]
		private static extern void SIOInitDDRCK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOInitDDRD" )]
		private static extern void SIOInitDDRDK(byte val);

		[DllImport("keybddr.dll", EntryPoint="SIOSetSSPTimeout" )]
		private static extern bool SIOSetSSPTimeoutK(ulong timeout);
		
		#endregion

		#region Exposed functions

		// functions try to call from smartio.dll first.  
		// if that fails, they call keybddr.dll
		// if that fails, they throw an exception

		public static uint FirmwareVersion()
		{
			try
			{
				return SIOFirmwareVersionS();
			}
			catch(Exception)
			{
				try
				{
					return SIOFirmwareVersionK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static uint DeviceVersion()
		{
			try
			{
				return SIOReadDeviceVersionS();
			}
			catch(Exception)
			{
				try
				{
					return SIOReadDeviceVersionK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static uint DevicePartType()
		{
			try
			{
				return SIOReadDevicePartTypeS();
			}
			catch(Exception)
			{
				try
				{
					return SIOReadDevicePartTypeK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static byte ReadKeypad()
		{
			try
			{
				return SIOReadKeypadS();
			}
			catch(Exception)
			{
				try
				{
					return SIOReadKeypadK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static bool SetKeyPadSize(byte Columns, byte Rows)
		{
			try
			{
				return SIOSetKeyPadSizeS(Columns, Rows);
			}
			catch(Exception)
			{
				try
				{
					return SIOSetKeyPadSizeK(Columns, Rows);

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
			
		public static bool SetSpeaker(byte Duration, byte Tone)
		{
			try
			{
				return SIOSetSpeakerS(Duration, Tone);
			}
			catch(Exception)
			{
				try
				{
					return SIOSetSpeakerK(Duration, Tone);

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
				
		public static uint AnalogConversion(byte Channel)
		{
			try
			{
				return SIOAnalogConversionS(Channel);
			}
			catch(Exception)
			{
				try
				{
					return SIOAnalogConversionK(Channel);

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static uint ReadVoltage()
		{
			try
			{
				return SIOReadVoltageS();
			}
			catch(Exception)
			{
				try
				{
					return SIOReadVoltageK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
		public static uint ReadTemperature()
		{
			try
			{
				return SIOReadTemperatureS();
			}
			catch(Exception)
			{
				try
				{
					return SIOReadTemperatureK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
		
		public static void SelectOption(byte OptionValue)
		{
			try
			{
				SIOSelectOptionS(OptionValue);
			}
			catch(Exception)
			{
				try
				{
					SIOSelectOptionK(OptionValue);

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static void BacklightPwm(byte NewValue)
		{
			try
			{
				SIOBackLightPwmS(NewValue);
			}
			catch(Exception)
			{
				try
				{
					SIOBackLightPwmK(NewValue);

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
		public static void VEEPwm(byte NewValue)
		{
			try
			{
				SIOBackLightVEEPwmS(NewValue);
			}
			catch(Exception)
			{
				try
				{
					SIOBackLightVEEPwmK(NewValue);

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static void BacklightOn()
		{
			try
			{
				SIOBackLightONS();
			}
			catch(Exception)
			{
				try
				{
					SIOBackLightONK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
		public static void BacklightOff()
		{
			try
			{
				SIOBackLightOFFS();
			}
			catch(Exception)
			{
				try
				{
					SIOBackLightOFFK();

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static bool SetSSPTimeout(ulong Timeout)
		{
			try
			{
				return SIOSetSSPTimeoutS(Timeout);
			}
			catch(Exception)
			{
				try
				{
					return SIOSetSSPTimeoutK(Timeout);

				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
		public static void WritePort(PortName Port, byte NewValue)
		{
			try
			{
				switch(Port)
				{
					case PortName.A:
						SIOWritePortAS(NewValue);
						break;
					case PortName.B:
						SIOWritePortBS(NewValue);
						break;
					case PortName.C:
						SIOWritePortCS(NewValue);
						break;
					case PortName.D:
						SIOWritePortDS(NewValue);
						break;
				}
			}
			catch(Exception)
			{
				try
				{
					switch(Port)
					{
						case PortName.A:
							SIOWritePortAK(NewValue);
							break;
						case PortName.B:
							SIOWritePortBK(NewValue);
							break;
						case PortName.C:
							SIOWritePortCK(NewValue);
							break;
						case PortName.D:
							SIOWritePortDK(NewValue);
							break;
					}
				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}
		public static uint ReadPort(PortName Port)
		{
			try
			{
				switch(Port)
				{
					case PortName.A:
						return SIOReadPortAS();
					case PortName.B:
						return SIOReadPortBS();
					case PortName.C:
						return SIOReadPortCS();
					case PortName.D:
						return SIOReadPortDS();
					default:
						return uint.MaxValue;
				}
			}
			catch(Exception)
			{
				try
				{
					switch(Port)
					{
						case PortName.A:
							return SIOReadPortAK();
						case PortName.B:
							return SIOReadPortBK();
						case PortName.C:
							return SIOReadPortCK();
						case PortName.D:
							return SIOReadPortDK();
						default:
							return uint.MaxValue;
					}
				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		public static void InitDDR(PortName Port, byte DDRValue)
		{
			try
			{
				switch(Port)
				{
					case PortName.A:
						SIOInitDDRAS(DDRValue);
						break;
					case PortName.B:
						SIOInitDDRBS(DDRValue);
						break;
					case PortName.C:
						SIOInitDDRCS(DDRValue);
						break;
					case PortName.D:
						SIOInitDDRDS(DDRValue);
						break;
				}
			}
			catch(Exception)
			{
				try
				{
					switch(Port)
					{
						case PortName.A:
							SIOInitDDRAK(DDRValue);
							break;
						case PortName.B:
							SIOInitDDRBK(DDRValue);
							break;
						case PortName.C:
							SIOInitDDRCK(DDRValue);
							break;
						case PortName.D:
							SIOInitDDRDK(DDRValue);
							break;
					}
				}
				catch(Exception e)
				{
					throw e;
				}
			}
		}

		#endregion
	}
}
